#ifndef unix
#ifdef _AIX
#define unix
#endif
#ifdef __ppc__     /* Darwin */
#define unix
#endif
#ifdef __OSF__      /* to je pro alphu */
#define unix
#endif
#ifdef __osf__
#define unix
#endif
#endif

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>
 
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>

#ifdef unix
#include <sys/types.h>
#include <sys/times.h>
#include <sys/time.h>
#include <sys/stat.h>
#endif

#ifndef unix
#include <processes.h>
#endif
 
#include "specific.h"
 
#define DEBUG
#define MXGC 100
#define MXPOINT 1000
#define MXCHAR 256
#define LARGEFIELD 20000
#define MXDWB 200
#define MXEMASK 30                /* max. pocet event mask */
#define MXENAME 20                /* max. delka nazvu event mask */
                                  /* nebo nazvu event            */
#define MXPAR 20
#define MXMISC 80
#define MXCUFO 100
#define MXEVTY 40
#define MXKEYSY 660
#define MXRASFN 20
#define MXBITS sizeof(XID)*8
#define MXISZL 5
#define FromFortranToC 1
#define FromCToFortran 2
#define MXFUNALEN 33
#define MAKETREE 1
#define PixmapDrawable 1
#define WindowDrawable 2
#define FillItKey 1
#define DrawItKey 2

#undef TYPE
#undef PROTOT
#undef ARG
#undef FORTRAN

#define RESET_TREE \
if(MAKETREE){ \
  (void)XCResetTree(); \
}
 
#define ADD_TO_TREE(x) \
if(MAKETREE){ \
  (void)strcpy(Funame,x); \
  (void)XCAddToTree(Funame); \
}


/******  function declarations ******/
 
/* Prototyp pro hlavni Fortransky podprogram volany z Mainu */
/* Musi to byt prvni prototyp v tomto souboru, protoze UNITM* */
/* jsou definovany ve specific.h a po provedeni alias.h */
/* ztrati definovanost */
#define FORTRAN
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGClose ***/
#define FORTRAN
#define UNITM  XGClose
#define UNITL  xgclose
#define UNITU  XGCLOSE
#define UNITM_ XGClose_
#define UNITL_ xgclose_
#define UNITU_ XGCLOSE_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGInit ***/
#define FORTRAN
#define UNITM  XGInit
#define UNITL  xginit
#define UNITU  XGINIT
#define UNITM_ XGInit_
#define UNITL_ xginit_
#define UNITU_ XGINIT_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *, unsigned int *);
#include "alias.h"

/*** FGClose ***/
#define FORTRAN
#define UNITM  FGClose
#define UNITL  fgclose
#define UNITU  FGCLOSE
#define UNITM_ FGClose_
#define UNITL_ fgclose_
#define UNITU_ FGCLOSE_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"
 
/*** XGLoadConstants ***/
#define FORTRAN
#define UNITM  XGLoadConstants
#define UNITL  xgloadconstants
#define UNITU  XGLOADCONSTANTS
#define UNITM_ XGLoadConstants_
#define UNITL_ xgloadconstants_
#define UNITU_ XGLOADCONSTANTS_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XFReadConstants_1 ***/
#define FORTRAN
#define UNITM  XFReadConstants_1
#define UNITL  xfreadconstants_1
#define UNITU  XFREADCONSTANTS_1
#define UNITM_ XFReadConstants_1_
#define UNITL_ xfreadconstants_1_
#define UNITU_ XFREADCONSTANTS_1_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XFReadConstants_2 ***/
#define FORTRAN
#define UNITM  XFReadConstants_2
#define UNITL  xfreadconstants_2
#define UNITU  XFREADCONSTANTS_2
#define UNITM_ XFReadConstants_2_
#define UNITL_ xfreadconstants_2_
#define UNITU_ XFREADCONSTANTS_2_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XFReadConstants_3 ***/
#define FORTRAN
#define UNITM  XFReadConstants_3
#define UNITL  xfreadconstants_3
#define UNITU  XFREADCONSTANTS_3
#define UNITM_ XFReadConstants_3_
#define UNITL_ xfreadconstants_3_
#define UNITU_ XFREADCONSTANTS_3_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XFReadConstants_4 ***/
#define FORTRAN
#define UNITM  XFReadConstants_4
#define UNITL  xfreadconstants_4
#define UNITU  XFREADCONSTANTS_4
#define UNITM_ XFReadConstants_4_
#define UNITL_ xfreadconstants_4_
#define UNITU_ XFREADCONSTANTS_4_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XFReadConstants_5 ***/
#define FORTRAN
#define UNITM  XFReadConstants_5
#define UNITL  xfreadconstants_5
#define UNITU  XFREADCONSTANTS_5
#define UNITM_ XFReadConstants_5_
#define UNITL_ xfreadconstants_5_
#define UNITU_ XFREADCONSTANTS_5_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XCLoadPom ***/
#define UNITM  XCLoadPom
#define TYPE   EXPORT void
#define PROTOT (int, int, char *);
#include "alias.h"
 
/*** XCNumOfBit ***/
#define UNITM  XCNumOfBit
#define TYPE   EXPORT int
#define PROTOT (unsigned long);
#include "alias.h"
 
/*** XGGetWindowAttributes ***/
#define UNITM  XGGetWindowAttributes
#define TYPE   EXPORT void
#define PROTOT (int);
#include "alias.h"
 
/*** XCPrintXSizeHints ***/
#define UNITM  XCPrintXSizeHints
#define TYPE   EXPORT void
#define PROTOT (XSizeHints *);
#include "alias.h"
 
/*** XCMoveXSizeHints ***/
#define UNITM  XCMoveXSizeHints
#define TYPE   EXPORT void
#define PROTOT (int, XSizeHints *, int);
#include "alias.h"
 
/*** XCMoveXWMHints ***/
#define UNITM  XCMoveXWMHints
#define TYPE   EXPORT void
#define PROTOT (int, XWMHints *, int);
#include "alias.h"
 
/*** XGPokus ***/
#define FORTRAN
#define UNITM  XGPokus
#define UNITL  xgpokus
#define UNITU  XGPOKUS
#define UNITM_ XGPokus_
#define UNITL_ xgpokus_
#define UNITU_ XGPOKUS_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XCMoveXSetWinAttr ***/
#define UNITM  XCMoveXSetWinAttr
#define TYPE   EXPORT void
#define PROTOT (int,XSetWindowAttributes *,int,\
                Window *,int *,int *,unsigned int *,unsigned int *,\
                unsigned int *, unsigned long *);
#include "alias.h"
 
/*** XCLongToBitArray   ***/
#define UNITM  XCLongToBitArray
#define TYPE   EXPORT void
#define PROTOT (long,int *);
#include "alias.h"
 
/*** XCXIDToBitArray ***/
#define UNITM  XCXIDToBitArray
#define TYPE   EXPORT void
#define PROTOT (XID,int *);
#include "alias.h"
 
/*** XCBitArrayToXID ***/
#define UNITM  XCBitArrayToXID
#define TYPE   EXPORT XID
#define PROTOT (int *);
#include "alias.h"
 
/*** XCBitArrayToLong ***/
#define UNITM  XCBitArrayToLong
#define TYPE   EXPORT long
#define PROTOT (int *);
#include "alias.h"
 
/*** XGOpenWindow ***/
#define FORTRAN
#define UNITM  XGOpenWindow
#define UNITL  xgopenwindow
#define UNITU  XGOPENWINDOW
#define UNITM_ XGOpenWindow_
#define UNITL_ xgopenwindow_
#define UNITU_ XGOPENWINDOW_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XGClearWindow ***/
#define FORTRAN
#define UNITM  XGClearWindow
#define UNITL  xgclearwindow
#define UNITU  XGCLEARWINDOW
#define UNITM_ XGClearWindow_
#define UNITL_ xgclearwindow_
#define UNITU_ XGCLEARWINDOW_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGFlush ***/
#define FORTRAN
#define UNITM  XGFlush
#define UNITL  xgflush
#define UNITU  XGFLUSH
#define UNITM_ XGFlush_
#define UNITL_ xgflush_
#define UNITU_ XGFLUSH_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"

/*** XGMapWindow ***/
#define FORTRAN
#define UNITM  XGMapWindow
#define UNITL  xgmapwindow
#define UNITU  XGMAPWINDOW
#define UNITM_ XGMapWindow_
#define UNITL_ xgmapwindow_
#define UNITU_ XGMAPWINDOW_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGMapSubwindows ***/
#define FORTRAN
#define UNITM  XGMapSubwindows
#define UNITL  xgmapsubwindows
#define UNITU  XGMAPSUBWINDOWS
#define UNITM_ XGMapSubwindows_
#define UNITL_ xgmapsubwindows_
#define UNITU_ XGMAPSUBWINDOWS_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGUnmapWindow ***/
#define FORTRAN
#define UNITM  XGUnmapWindow
#define UNITL  xgunmapwindow
#define UNITU  XGUNMAPWINDOW
#define UNITM_ XGUnmapWindow_
#define UNITL_ xgunmapwindow_
#define UNITU_ XGUNMAPWINDOW_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGUnmapSubwindows ***/
#define FORTRAN
#define UNITM  XGUnmapSubwindows
#define UNITL  xgunmapsubwindows
#define UNITU  XGUNMAPSUBWINDOWS
#define UNITM_ XGUnmapSubwindows_
#define UNITL_ xgunmapsubwindows_
#define UNITU_ XGUNMAPSUBWINDOWS_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGDestroyWindow ***/
#define FORTRAN
#define UNITM  XGDestroyWindow
#define UNITL  xgdestroywindow
#define UNITU  XGDESTROYWINDOW
#define UNITM_ XGDestroyWindow_
#define UNITL_ xgdestroywindow_
#define UNITU_ XGDESTROYWINDOW_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGDestroySubwindows ***/
#define FORTRAN
#define UNITM  XGDestroySubwindows
#define UNITL  xgdestroysubwindows
#define UNITU  XGDESTROYSUBWINDOWS
#define UNITM_ XGDestroySubwindows_
#define UNITL_ xgdestroysubwindows_
#define UNITU_ XGDESTROYSUBWINDOWS_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XCWaitForExpose ***/
#define UNITM  XCWaitForExpose
#define TYPE   EXPORT void
#define PROTOT (Window);
#include "alias.h"

/*** XGLine ***/
#define FORTRAN
#define UNITM  XGLine
#define UNITL  xgline
#define UNITU  XGLINE
#define UNITM_ XGLine_
#define UNITL_ xgline_
#define UNITU_ XGLINE_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *, int *);
#include "alias.h"
 
/*** XGLines ***/
#define FORTRAN
#define UNITM  XGLines
#define UNITL  xglines
#define UNITU  XGLINES
#define UNITM_ XGLines_
#define UNITL_ xglines_
#define UNITU_ XGLINES_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"

/*** XGPoint ***/
#define FORTRAN
#define UNITM  XGPoint
#define UNITL  xgpoint
#define UNITU  XGPOINT
#define UNITM_ XGPoint_
#define UNITL_ xgpoint_
#define UNITU_ XGPOINT_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"
 
/*** XGPoints ***/
#define FORTRAN
#define UNITM  XGPoints
#define UNITL  xgpoints
#define UNITU  XGPOINTS
#define UNITM_ XGPoints_
#define UNITL_ xgpoints_
#define UNITU_ XGPOINTS_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XGMask ***/
#define FORTRAN
#define UNITM  XGMask
#define UNITL  xgmask
#define UNITU  XGMASK
#define UNITM_ XGMask_
#define UNITL_ xgmask_
#define UNITU_ XGMASK_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XGSetWMName ***/
#define FORTRAN
#define UNITM  XGSetWMName
#define UNITL  xgsetwmname
#define UNITU  XGSETWMNAME
#define UNITM_ XGSetWMName_
#define UNITL_ xgsetwmname_
#define UNITU_ XGSETWMNAME_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSetWMIconName ***/
#define FORTRAN
#define UNITM  XGSetWMIconName
#define UNITL  xgsetwmiconname
#define UNITU  XGSETWMICONNAME
#define UNITM_ XGSetWMIconName_
#define UNITL_ xgsetwmiconname_
#define UNITU_ XGSETWMICONNAME_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGWriteToScreen ***/
#define FORTRAN
#define UNITM  XGWriteToScreen
#define UNITL  xgwritetoscreen
#define UNITU  XGWRITETOSCREEN
#define UNITM_ XGWriteToScreen_
#define UNITL_ xgwritetoscreen_
#define UNITU_ XGWRITETOSCREEN_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XGGetClassHint ***/
#define FORTRAN
#define UNITM  XGGetClassHint
#define UNITL  xggetclasshint
#define UNITU  XGGETCLASSHINT
#define UNITM_ XGGetClassHint_
#define UNITL_ xggetclasshint_
#define UNITU_ XGGETCLASSHINT_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XCset_mask_field ***/
#define UNITM  XCset_mask_field
#define TYPE   EXPORT void
#define PROTOT (char *, int *, int, char *);
#include "alias.h"
 
/*** XCMkMask ***/
#define UNITM  XCMkMask
#define TYPE   EXPORT long
#define PROTOT (int *);
#include "alias.h"
 
/*** XCStringToIntArray ***/
#define UNITM  XCStringToIntArray
#define TYPE   EXPORT void
#define PROTOT (char *, int *);
#include "alias.h"
 
/*** XCIntArrayToString ***/
#define UNITM  XCIntArrayToString
#define TYPE   EXPORT void
#define PROTOT (int *, char *);
#include "alias.h"
 
/*** FGSetWMProperties ***/
#define FORTRAN
#define UNITM  FGSetWMProperties
#define UNITL  fgsetwmproperties
#define UNITU  FGSETWMPROPERTIES
#define UNITM_ FGSetWMProperties_
#define UNITL_ fgsetwmproperties_
#define UNITU_ FGSETWMPROPERTIES_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XFMoveXSizeHints ***/
#define FORTRAN
#define UNITM  XFMoveXSizeHints
#define UNITL  xfmovexsizehints
#define UNITU  XFMOVEXSIZEHINTS
#define UNITM_ XFMoveXSizeHints_
#define UNITL_ xfmovexsizehints_
#define UNITU_ XFMOVEXSIZEHINTS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,\
                int *);
#include "alias.h"
 
/*** XFMoveXWMHints ***/
#define FORTRAN
#define UNITM  XFMoveXWMHints
#define UNITL  xfmovexwmhints
#define UNITU  XFMOVEXWMHINTS
#define UNITM_ XFMoveXWMHints_
#define UNITL_ xfmovexwmhints_
#define UNITU_ XFMOVEXWMHINTS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,Bool *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *);
#include "alias.h"
 
/*** XFMoveXSetWinAttr ***/
#define FORTRAN
#define UNITM  XFMoveXSetWinAttr
#define UNITL  xfmovexsetwinattr
#define UNITU  XFMOVEXSETWINATTR
#define UNITM_ XFMoveXSetWinAttr_
#define UNITL_ xfmovexsetwinattr_
#define UNITU_ XFMOVEXSETWINATTR_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,\
                unsigned int *,unsigned int *,unsigned int *,\
                int *,\
                int *,int *,int *,int *,\
                int *,int *,\
                int *,int *,int *,\
                Bool *,int *,int *,\
                Bool *,int *,int *);
#include "alias.h"

/*** XGGetPixel ***/
#define FORTRAN
#define UNITM  XGGetPixel
#define UNITL  xggetpixel
#define UNITU  XGGETPIXEL
#define UNITM_ XGGetPixel_
#define UNITL_ xggetpixel_
#define UNITU_ XGGETPIXEL_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGGetCommand ***/
#define FORTRAN
#define UNITM  XGGetCommand
#define UNITL  xggetcommand
#define UNITU  XGGETCOMMAND
#define UNITM_ XGGetCommand_
#define UNITL_ xggetcommand_
#define UNITU_ XGGETCOMMAND_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XGGetIconName ***/
#define FORTRAN
#define UNITM  XGGetIconName
#define UNITL  xggeticonname
#define UNITU  XGGETICONNAME
#define UNITM_ XGGetIconName_
#define UNITL_ xggeticonname_
#define UNITU_ XGGETICONNAME_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGFetchName ***/
#define FORTRAN
#define UNITM  XGFetchName
#define UNITL  xgfetchname
#define UNITU  XGFETCHNAME
#define UNITM_ XGFetchName_
#define UNITL_ xgfetchname_
#define UNITU_ XGFETCHNAME_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGGetIconSizes ***/
#define FORTRAN
#define UNITM  XGGetIconSizes
#define UNITL  xggeticonsizes
#define UNITU  XGGETICONSIZES
#define UNITM_ XGGetIconSizes_
#define UNITL_ xggeticonsizes_
#define UNITU_ XGGETICONSIZES_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGGetWMNormalHints ***/
#define FORTRAN
#define UNITM  XGGetWMNormalHints
#define UNITL  xggetwmnormalhints
#define UNITU  XGGETWMNORMALHINTS
#define UNITM_ XGGetWMNormalHints_
#define UNITL_ xggetwmnormalhints_
#define UNITU_ XGGETWMNORMALHINTS_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"
 
/*** XGSetWMSizeHints ***/
#define FORTRAN
#define UNITM  XGSetWMSizeHints
#define UNITL  xgsetwmsizehints
#define UNITU  XGSETWMSIZEHINTS
#define UNITM_ XGSetWMSizeHints_
#define UNITL_ xgsetwmsizehints_
#define UNITU_ XGSETWMSIZEHINTS_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSetWMProperties ***/
#define FORTRAN
#define UNITM  XGSetWMProperties
#define UNITL  xgsetwmproperties
#define UNITU  XGSETWMPROPERTIES
#define UNITM_ XGSetWMProperties_
#define UNITL_ xgsetwmproperties_
#define UNITU_ XGSETWMPROPERTIES_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *, int *, int *, int *, \
                int *, int *, int *, int *);
#include "alias.h"

/*** XFAddToTreeFromC ***/
#define FORTRAN
#define UNITM  XFAddToTreeFromC
#define UNITL  xfaddtotreefromc
#define UNITU  XFADDTOTREEFROMC
#define UNITM_ XFAddToTreeFromC_
#define UNITL_ xfaddtotreefromc_
#define UNITU_ XFADDTOTREEFROMC_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"

/*** XFResetTreeFromC ***/
#define FORTRAN
#define UNITM  XFResetTreeFromC
#define UNITL  xfresettreefromc
#define UNITU  XFRESETTREEFROMC
#define UNITM_ XFResetTreeFromC_
#define UNITL_ xfresettreefromc_
#define UNITU_ XFRESETTREEFROMC_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XCAddToTree ***/
#define UNITM  XCAddToTree
#define TYPE   EXPORT void
#define PROTOT (char *);
#include "alias.h"
 
/*** XCResetTree ***/
#define UNITM  XCResetTree
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"

#define UNITM  malloc
#define TYPE   EXPORT void*
#define PROTOT (size_t);
#include "alias.h"
 
#define UNITM  free
#define TYPE   EXPORT void
#define PROTOT (void *);
#include "alias.h"

#define UNITM  fgetc
#define TYPE   EXPORT int
#define PROTOT (FILE *);
#include "alias.h"

#define UNITM  fputc
#define TYPE   EXPORT int
#define PROTOT (int, FILE *);
#include "alias.h"

/*** XGReadBitmapFile ***/
#define FORTRAN
#define UNITM  XGReadBitmapFile
#define UNITL  xgreadbitmapfile
#define UNITU  XGREADBITMAPFILE
#define UNITM_ XGReadBitmapFile_
#define UNITL_ xgreadbitmapfile_
#define UNITU_ XGREADBITMAPFILE_
#define TYPE   EXPORT void
#define PROTOT (int*, int*);
#include "alias.h"

/*** XCErrorMessage ***/
#define UNITM XCErrorMessage
#define TYPE EXPORT void
#define PROTOT (int);
#include "alias.h"

/*** XFErrorMessage ***/
#define FORTRAN
#define UNITM  XFErrorMessage
#define UNITL  xferrormessage
#define UNITU  XFERRORMESSAGE
#define UNITM_ XFErrorMessage_
#define UNITL_ xferrormessage_
#define UNITU_ XFERRORMESSAGE_
#define TYPE   EXPORT void
#define PROTOT (int*, int*);
#include "alias.h"

/*** XGQueryBestTile ***/
#define FORTRAN
#define UNITM  XGQueryBestTile
#define UNITL  xgquerybesttile
#define UNITU  XGQUERYBESTTILE
#define UNITM_ XGQueryBestTile_
#define UNITL_ xgquerybesttile_
#define UNITU_ XGQUERYBESTTILE_
#define TYPE   EXPORT void
#define PROTOT (unsigned int *, unsigned int *, unsigned int *, unsigned int *);
#include "alias.h"

/*** XGQueryBestStipple ***/
#define FORTRAN
#define UNITM  XGQueryBestStipple
#define UNITL  xgquerybeststipple
#define UNITU  XGQUERYBESTSTIPPLE
#define UNITM_ XGQueryBestStipple_
#define UNITL_ xgquerybeststipple_
#define UNITU_ XGQUERYBESTSTIPPLE_
#define TYPE   EXPORT void
#define PROTOT (unsigned int *,unsigned int *,unsigned int *,unsigned int *);
#include "alias.h"

/*** XGCopyPlane ***/
#define FORTRAN
#define UNITM  XGCopyPlane
#define UNITL  xgcopyplane
#define UNITU  XGCOPYPLANE
#define UNITM_ XGCopyPlane_
#define UNITL_ xgcopyplane_
#define UNITU_ XGCOPYPLANE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,unsigned int *,unsigned int *, \
                int *,int *,int *);
#include "alias.h"

/*** XGSetCurrentWin ***/
#define FORTRAN
#define UNITM  XGSetCurrentDrawable
#define UNITL  xgsetcurrentdrawable
#define UNITU  XGSETCURRENTDRAWABLE
#define UNITM_ XGSetCurrentDrawable_
#define UNITL_ xgsetcurrentdrawable_
#define UNITU_ XGSETCURRENTDRAWABLE_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"

/*** XGSetCurrentGC ***/
#define FORTRAN
#define UNITM  XGSetCurrentGC
#define UNITL  xgsetcurrentgc
#define UNITU  XGSETCURRENTGC
#define UNITM_ XGSetCurrentGC_
#define UNITL_ xgsetcurrentgc_
#define UNITU_ XGSETCURRENTGC_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"

/*** XGGetGeometry ***/
#define FORTRAN
#define UNITM  XGGetGeometry
#define UNITL  xggetgeometry
#define UNITU  XGGETGEOMETRY
#define UNITM_ XGGetGeometry_
#define UNITL_ xggetgeometry_
#define UNITU_ XGGETGEOMETRY_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,unsigned int *,unsigned int *, \
                unsigned int *, unsigned int *);
#include "alias.h"

/*** XGCreatePixmap ***/
#define FORTRAN
#define UNITM  XGCreatePixmap
#define UNITL  xgcreatepixmap
#define UNITU  XGCREATEPIXMAP
#define UNITM_ XGCreatePixmap_
#define UNITL_ xgcreatepixmap_
#define UNITU_ XGCREATEPIXMAP_
#define TYPE   EXPORT void
#define PROTOT (int *,unsigned int *,unsigned int *, unsigned int *);
#include "alias.h"

/*** XGFreePixmap ***/
#define FORTRAN
#define UNITM  XGFreePixmap
#define UNITL  xgfreepixmap
#define UNITU  XGFREEPIXMAP
#define UNITM_ XGFreePixmap_
#define UNITL_ xgfreepixmap_
#define UNITU_ XGFREEPIXMAP_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"

/*** XCMoveXGCVal ***/
#define UNITM XCMoveXGCVal
#define TYPE EXPORT void
#define PROTOT (int, XGCValues *, int, unsigned long *);
#include "alias.h"

/*** XFMoveXGCVal ***/
#define FORTRAN
#define UNITM  XFMoveXGCVal
#define UNITL  xfmovexgcval
#define UNITU  XFMOVEXGCVAL
#define UNITM_ XFMoveXGCVal_
#define UNITL_ xfmovexgcval_
#define UNITU_ XFMOVEXGCVAL_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,\
                int *,int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,\
                int *,int *,int *,int *,\
                int *,int *,\
                Bool *,int *,\
                int *,int *,int *,\
                int *);
#include "alias.h"
 
/*** XGCreateGC ***/
#define FORTRAN
#define UNITM  XGCreateGC
#define UNITL  xgcreategc
#define UNITU  XGCREATEGC
#define UNITM_ XGCreateGC_
#define UNITL_ xgcreategc_
#define UNITU_ XGCREATEGC_
#define TYPE   EXPORT void
#define PROTOT (int*, int*);
#include "alias.h"

/*** XGFreeGC ***/
#define FORTRAN
#define UNITM  XGFreeGC
#define UNITL  xgfreegc
#define UNITU  XGFREEGC
#define UNITM_ XGFreeGC_
#define UNITL_ xgfreegc_
#define UNITU_ XGFREEGC_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"

/*** XCMoveEventStructure ***/
#define UNITM XCMoveEventStructure
#define TYPE EXPORT void
#define PROTOT (XEvent *);
#include "alias.h"

/*** XFMoveEventStructure ***/
#define FORTRAN
#define UNITM  XFMoveEventStructure
#define UNITL  xfmoveeventstructure
#define UNITU  XFMOVEEVENTSTRUCTURE
#define UNITM_ XFMoveEventStructure_
#define UNITL_ xfmoveeventstructure_
#define UNITU_ XFMOVEEVENTSTRUCTURE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *,\
                    int *,int *,int *,\
                int *,int *,int *,int *,\
                int *,int *,\
                int *,int *,int *,int *,int *,int *,int *,\
                int *,int *,int *,int *,int *,int *,int *,\
                    int *,int *,int *,int *,int *,\
                int *,int *,int *,int *,int *,int *,\
                    int *,int *,int *,int *,int *,int *,int *,\
                int *,int *,int *,int *);
#include "alias.h"
 
/*** XGSelectInput ***/
#define FORTRAN
#define UNITM  XGSelectInput
#define UNITL  xgselectinput
#define UNITU  XGSELECTINPUT
#define UNITM_ XGSelectInput_
#define UNITL_ xgselectinput_
#define UNITU_ XGSELECTINPUT_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 

/*** XGNextEvent ***/
#define FORTRAN
#define UNITM  XGNextEvent
#define UNITL  xgnextevent
#define UNITU  XGNEXTEVENT
#define UNITM_ XGNextEvent_
#define UNITL_ xgnextevent_
#define UNITU_ XGNEXTEVENT_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"

/*** XGSetTransientForHint ***/
#define FORTRAN
#define UNITM  XGSetTransientForHint
#define UNITL  xgsettransientforhint
#define UNITU  XGSETTRANSIENTFORHINT
#define UNITM_ XGSetTransientForHint_
#define UNITL_ xgsettransientforhint_
#define UNITU_ XGSETTRANSIENTFORHINT_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XFMoveXWinAttr ***/
#define FORTRAN
#define UNITM  XFMoveXWinAttr
#define UNITL  xfmovexwinattr
#define UNITU  XFMOVEXWINATTR
#define UNITM_ XFMoveXWinAttr_
#define UNITL_ xfmovexwinattr_
#define UNITU_ XFMOVEXWINATTR_
#define TYPE   EXPORT void
#define PROTOT (int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *);
#include "alias.h"

/*** XGCreateSimpleWindow ***/
#define FORTRAN
#define UNITM  XGCreateSimpleWindow
#define UNITL  xgcreatesimplewindow
#define UNITU  XGCREATESIMPLEWINDOW
#define UNITM_ XGCreateSimpleWindow_
#define UNITL_ xgcreatesimplewindow_
#define UNITU_ XGCREATESIMPLEWINDOW_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *, \
                int *,int *);
#include "alias.h"

/*** XFMoveXIconSize ***/
#define FORTRAN
#define UNITM  XFMoveXIconSize
#define UNITL  xfmovexiconsize
#define UNITU  XFMOVEXICONSIZE
#define UNITM_ XFMoveXIconSize_
#define UNITL_ xfmovexiconsize_
#define UNITU_ XFMOVEXICONSIZE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *, \
                int *,int *,int *);
#include "alias.h"
 
/*** XGKeycodeToString ***/
#define FORTRAN
#define UNITM  XGKeycodeToString
#define UNITL  xgkeycodetostring
#define UNITU  XGKEYCODETOSTRING
#define UNITM_ XGKeycodeToString_
#define UNITL_ xgkeycodetostring_
#define UNITU_ XGKEYCODETOSTRING_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGWarpPointer ***/
#define FORTRAN
#define UNITM  XGWarpPointer
#define UNITL  xgwarppointer
#define UNITU  XGWARPPOINTER
#define UNITM_ XGWarpPointer_
#define UNITL_ xgwarppointer_
#define UNITU_ XGWARPPOINTER_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,unsigned int *,unsigned int *, \
                int *,int *);
#include "alias.h"
 
/*** XGLookupString ***/
#define FORTRAN
#define UNITM  XGLookupString
#define UNITL  xglookupstring
#define UNITU  XGLOOKUPSTRING
#define UNITM_ XGLookupString_
#define UNITL_ xglookupstring_
#define UNITU_ XGLOOKUPSTRING_
#define TYPE   EXPORT void
#define PROTOT (int *,int *, int *);
#include "alias.h"
 
/*** XGRebindKeysym ***/
#define FORTRAN
#define UNITM  XGRebindKeysym
#define UNITL  xgrebindkeysym
#define UNITU  XGREBINDKEYSYM
#define UNITM_ XGRebindKeysym_
#define UNITL_ xgrebindkeysym_
#define UNITU_ XGREBINDKEYSYM_
#define TYPE   EXPORT void
#define PROTOT (int *,int *, int *, int *, int *);
#include "alias.h"
 
/*** XGDisplayKeycodes ***/
#define FORTRAN
#define UNITM  XGDisplayKeycodes
#define UNITL  xgdisplaykeycodes
#define UNITU  XGDISPLAYKEYCODES
#define UNITM_ XGDisplayKeycodes_
#define UNITL_ xgdisplaykeycodes_
#define UNITU_ XGDISPLAYKEYCODES_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"
 
/*** XGGetKeyboardMapping ***/
#define FORTRAN
#define UNITM  XGGetKeyboardMapping
#define UNITL  xggetkeyboardmapping
#define UNITU  XGGETKEYBOARDMAPPING
#define UNITM_ XGGetKeyboardMapping_
#define UNITL_ xggetkeyboardmapping_
#define UNITU_ XGGETKEYBOARDMAPPING_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, int *);
#include "alias.h"
 
/*** XGKeysymToString ***/
#define FORTRAN
#define UNITM  XGKeysymToString
#define UNITL  xgkeysymtostring
#define UNITU  XGKEYSYMTOSTRING
#define UNITM_ XGKeysymToString_
#define UNITL_ xgkeysymtostring_
#define UNITU_ XGKEYSYMTOSTRING_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"
 
/*** XGListFonts ***/
#define FORTRAN
#define UNITM  XGListFonts
#define UNITL  xglistfonts
#define UNITU  XGLISTFONTS
#define UNITM_ XGListFonts_
#define UNITL_ xglistfonts_
#define UNITU_ XGLISTFONTS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGListFontsToFile ***/
#define FORTRAN
#define UNITM  XGListFontsToFile
#define UNITL  xglistfontstofile
#define UNITU  XGLISTFONTSTOFILE
#define UNITM_ XGListFontsToFile_
#define UNITL_ xglistfontstofile_
#define UNITU_ XGLISTFONTSTOFILE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGGetFontInfo ***/
#define FORTRAN
#define UNITM  XGGetFontInfo
#define UNITL  xggetfontinfo
#define UNITU  XGGETFONTINFO
#define UNITM_ XGGetFontInfo_
#define UNITL_ xggetfontinfo_
#define UNITU_ XGGETFONTINFO_
#define TYPE   EXPORT void
#define PROTOT (int *, int *);
#include "alias.h"
 
#define FORTRAN
#define UNITM  XFMoveXFontInfo
#define UNITL  xfmovexfontinfo
#define UNITU  XFMOVEXFONTINFO
#define UNITM_ XFMoveXFontInfo_
#define UNITL_ xfmovexfontinfo_
#define UNITU_ XFMOVEXFONTINFO_
#define TYPE   EXPORT void
#define PROTOT (int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *);
#include "alias.h"

#define FORTRAN
#define UNITM  XFMoveXFontStruct
#define UNITL  xfmovexfontstruct
#define UNITU  XFMOVEXFONTSTRUCT
#define UNITM_ XFMoveXFontStruct_
#define UNITL_ xfmovexfontstruct_
#define UNITU_ XFMOVEXFONTSTRUCT_
#define TYPE   EXPORT void
#define PROTOT (int *, int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *, \
                int *);
#include "alias.h"

/*** XCMoveXFontInfo ***/
#define UNITM  XCMoveXFontInfo
#define TYPE   EXPORT void
#define PROTOT (XFontStruct *, int);
#include "alias.h"

/*** XCMoveXFontStruct ***/
#define UNITM  XCMoveXFontStruct
#define TYPE   EXPORT void
#define PROTOT (int, XFontStruct *, int);
#include "alias.h"
 
/*** XGLoadQueryFont ***/
#define FORTRAN
#define UNITM  XGLoadQueryFont
#define UNITL  xgloadqueryfont
#define UNITU  XGLOADQUERYFONT
#define UNITM_ XGLoadQueryFont_
#define UNITL_ xgloadqueryfont_
#define UNITU_ XGLOADQUERYFONT_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGUnloadFont ***/
#define FORTRAN
#define UNITM  XGUnloadFont
#define UNITL  xgunloadfont
#define UNITU  XGUNLOADFONT
#define UNITM_ XGUnloadFont_
#define UNITL_ xgunloadfont_
#define UNITU_ XGUNLOADFONT_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGDrawString ***/
#define FORTRAN
#define UNITM  XGDrawString
#define UNITL  xgdrawstring
#define UNITU  XGDRAWSTRING
#define UNITM_ XGDrawString_
#define UNITL_ xgdrawstring_
#define UNITU_ XGDRAWSTRING_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGCopyArea ***/
#define FORTRAN
#define UNITM  XGCopyArea
#define UNITL  xgcopyarea
#define UNITU  XGCOPYAREA
#define UNITM_ XGCopyArea_
#define UNITL_ xgcopyarea_
#define UNITU_ XGCOPYAREA_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGFillRectangle ***/
#define FORTRAN
#define UNITM  XGFillRectangle
#define UNITL  xgfillrectangle
#define UNITU  XGFILLRECTANGLE
#define UNITM_ XGFillRectangle_
#define UNITL_ xgfillrectangle_
#define UNITU_ XGFILLRECTANGLE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *, int *);
#include "alias.h"
 
/*** XGFillRectangles ***/
#define FORTRAN
#define UNITM  XGFillRectangles
#define UNITL  xgfillrectangles
#define UNITU  XGFILLRECTANGLES
#define UNITM_ XGFillRectangles_
#define UNITL_ xgfillrectangles_
#define UNITU_ XGFILLRECTANGLES_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *, int *, int *);
#include "alias.h"
 
/*** XGTextExtents ***/
#define FORTRAN
#define UNITM  XGTextExtents
#define UNITL  xgtextextents
#define UNITU  XGTEXTEXTENTS
#define UNITM_ XGTextExtents_
#define UNITL_ xgtextextents_
#define UNITU_ XGTEXTEXTENTS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *,int *,\
                int *,int *,int *);
#include "alias.h"
 
/*** XGQueryTextExtents ***/
#define FORTRAN
#define UNITM  XGQueryTextExtents
#define UNITL  xgquerytextextents
#define UNITU  XGQUERYTEXTEXTENTS
#define UNITM_ XGQueryTextExtents_
#define UNITL_ xgquerytextextents_
#define UNITU_ XGQUERYTEXTEXTENTS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *,int *,\
                int *,int *,int *);
#include "alias.h"
 
/*** XGLoadFont ***/
#define FORTRAN
#define UNITM  XGLoadFont
#define UNITL  xgloadfont
#define UNITU  XGLOADFONT
#define UNITM_ XGLoadFont_
#define UNITL_ xgloadfont_
#define UNITU_ XGLOADFONT_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGSync ***/
#define FORTRAN
#define UNITM  XGSync
#define UNITL  xgsync
#define UNITU  XGSYNC
#define UNITM_ XGSync_
#define UNITL_ xgsync_
#define UNITU_ XGSYNC_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSync ***/
#define FORTRAN
#define UNITM  XGSynchronize
#define UNITL  xgsynchronize
#define UNITU  XGSYNCHRONIZE
#define UNITM_ XGSynchronize_
#define UNITL_ xgsynchronize_
#define UNITU_ XGSYNCHRONIZE_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGNoOp ***/
#define FORTRAN
#define UNITM  XGNoOp
#define UNITL  xgnoop
#define UNITU  XGNOOP
#define UNITM_ XGNoOp_
#define UNITL_ xgnoop_
#define UNITU_ XGNOOP_
#define TYPE   EXPORT void
#define PROTOT ();
#include "alias.h"
 
/*** XGSetTile ***/
#define FORTRAN
#define UNITM  XGSetTile
#define UNITL  xgsettile
#define UNITU  XGSETTILE
#define UNITM_ XGSetTile_
#define UNITL_ xgsettile_
#define UNITU_ XGSETTILE_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSetStipple ***/
#define FORTRAN
#define UNITM  XGSetStipple
#define UNITL  xgsetstipple
#define UNITU  XGSETSTIPPLE
#define UNITM_ XGSetStipple_
#define UNITL_ xgsetstipple_
#define UNITU_ XGSETSTIPPLE_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGFillPolygon ***/
#define FORTRAN
#define UNITM  XGFillPolygon
#define UNITL  xgfillpolygon
#define UNITU  XGFILLPOLYGON
#define UNITM_ XGFillPolygon_
#define UNITL_ xgfillpolygon_
#define UNITU_ XGFILLPOLYGON_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGCreateFontCursor ***/
#define FORTRAN
#define UNITM  XGCreateFontCursor
#define UNITL  xgcreatefontcursor
#define UNITU  XGCREATEFONTCURSOR
#define UNITM_ XGCreateFontCursor_
#define UNITL_ xgcreatefontcursor_
#define UNITU_ XGCREATEFONTCURSOR_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGFreeCursor ***/
#define FORTRAN
#define UNITM  XGFreeCursor
#define UNITL  xgfreecursor
#define UNITU  XGFREECURSOR
#define UNITM_ XGFreeCursor_
#define UNITL_ xgfreecursor_
#define UNITU_ XGFREECURSOR_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGDefineCursor ***/
#define FORTRAN
#define UNITM  XGDefineCursor
#define UNITL  xgdefinecursor
#define UNITU  XGDEFINECURSOR
#define UNITM_ XGDefineCursor_
#define UNITL_ xgdefinecursor_
#define UNITU_ XGDEFINECURSOR_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGWindowEvent ***/
#define FORTRAN
#define UNITM  XGWindowEvent
#define UNITL  xgwindowevent
#define UNITU  XGWINDOWEVENT
#define UNITM_ XGWindowEvent_
#define UNITL_ xgwindowevent_
#define UNITU_ XGWINDOWEVENT_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGCheckWindowEvent ***/
#define FORTRAN
#define UNITM  XGCheckWindowEvent
#define UNITL  xgcheckwindowevent
#define UNITU  XGCHECKWINDOWEVENT
#define UNITM_ XGCheckWindowEvent_
#define UNITL_ xgcheckwindowevent_
#define UNITU_ XGCHECKWINDOWEVENT_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGQueryPointer ***/
#define FORTRAN
#define UNITM  XGQueryPointer
#define UNITL  xgquerypointer
#define UNITU  XGQUERYPOINTER
#define UNITM_ XGQueryPointer_
#define UNITL_ xgquerypointer_
#define UNITU_ XGQUERYPOINTER_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *, int *);
#include "alias.h"
 
/*** XGGrabKeyboard ***/
#define FORTRAN
#define UNITM  XGGrabKeyboard
#define UNITL  xggrabkeyboard
#define UNITU  XGGRABKEYBOARD
#define UNITM_ XGGrabKeyboard_
#define UNITL_ xggrabkeyboard_
#define UNITU_ XGGRABKEYBOARD_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGUngrabKeyboard ***/
#define FORTRAN
#define UNITM  XGUngrabKeyboard
#define UNITL  xgungrabkeyboard
#define UNITU  XGUNGRABKEYBOARD
#define UNITM_ XGUngrabKeyboard_
#define UNITL_ xgungrabkeyboard_
#define UNITU_ XGUNGRABKEYBOARD_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XCMoveXVisualInfo ***/
#define UNITM XCMoveXVisualInfo
#define TYPE EXPORT void
#define PROTOT (XVisualInfo *, int);
#include "alias.h"
 
/*** XGMoveXVisualInfo ***/
#define FORTRAN
#define UNITM  XFMoveXVisualInfo
#define UNITL  xfmovexvisualinfo
#define UNITU  XFMOVEXVISUALINFO
#define UNITM_ XFMoveXVisualInfo_
#define UNITL_ xfmovexvisualinfo_
#define UNITU_ XFMOVEXVISUALINFO_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *, \
                int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGMatchVisualInfo ***/
#define FORTRAN
#define UNITM  XGMatchVisualInfo
#define UNITL  xgmatchvisualinfo
#define UNITU  XGMATCHVISUALINFO
#define UNITM_ XGMatchVisualInfo_
#define UNITL_ xgmatchvisualinfo_
#define UNITU_ XGMATCHVISUALINFO_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGBlackPixel ***/
#define FORTRAN
#define UNITM  XGBlackPixel
#define UNITL  xgblackpixel
#define UNITU  XGBLACKPIXEL
#define UNITM_ XGBlackPixel_
#define UNITL_ xgblackpixel_
#define UNITU_ XGBLACKPIXEL_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGWhitePixel ***/
#define FORTRAN
#define UNITM  XGWhitePixel
#define UNITL  xgwhitepixel
#define UNITU  XGWHITEPIXEL
#define UNITM_ XGWhitePixel_
#define UNITL_ xgwhitepixel_
#define UNITU_ XGWHITEPIXEL_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGDefaultColormap ***/
#define FORTRAN
#define UNITM  XGDefaultColormap
#define UNITL  xgdefaultcolormap
#define UNITU  XGDEFAULTCOLORMAP
#define UNITM_ XGDefaultColormap_
#define UNITL_ xgdefaultcolormap_
#define UNITU_ XGDEFAULTCOLORMAP_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGParseColor ***/
#define FORTRAN
#define UNITM  XGParseColor
#define UNITL  xgparsecolor
#define UNITU  XGPARSECOLOR
#define UNITM_ XGParseColor_
#define UNITL_ xgparsecolor_
#define UNITU_ XGPARSECOLOR_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XGNArgs ***/
#define FORTRAN
#define UNITM  XGNArgs
#define UNITL  xgnargs
#define UNITU  XGNARGS
#define UNITM_ XGNArgs_
#define UNITL_ xgnargs_
#define UNITU_ XGNARGS_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGGetArg ***/
#define FORTRAN
#define UNITM  XGGetArg
#define UNITL  xggetarg
#define UNITU  XGGETARG
#define UNITM_ XGGetArg_
#define UNITL_ xggetarg_
#define UNITU_ XGGETARG_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGSetFunction ***/
#define FORTRAN
#define UNITM  XGSetFunction
#define UNITL  xgsetfunction
#define UNITU  XGSETFUNCTION
#define UNITM_ XGSetFunction_
#define UNITL_ xgsetfunction_
#define UNITU_ XGSETFUNCTION_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGFillArc ***/
#define FORTRAN
#define UNITM  XGFillArc
#define UNITL  xgfillarc
#define UNITU  XGFILLARC
#define UNITM_ XGFillArc_
#define UNITL_ xgfillarc_
#define UNITU_ XGFILLARC_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGFillArcs ***/
#define FORTRAN
#define UNITM  XGFillArcs
#define UNITL  xgfillarcs
#define UNITU  XGFILLARCS
#define UNITM_ XGFillArcs_
#define UNITL_ xgfillarcs_
#define UNITU_ XGFILLARCS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGGetProgramName ***/
#define FORTRAN
#define UNITM  XGGetProgramName
#define UNITL  xggetprogramname
#define UNITU  XGGETPROGRAMNAME
#define UNITM_ XGGetProgramName_
#define UNITL_ xggetprogramname_
#define UNITU_ XGGETPROGRAMNAME_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGResizeWindow ***/
#define FORTRAN
#define UNITM  XGResizeWindow
#define UNITL  xgresizewindow
#define UNITU  XGRESIZEWINDOW
#define UNITM_ XGResizeWindow_
#define UNITL_ xgresizewindow_
#define UNITU_ XGRESIZEWINDOW_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGMoveWindow ***/
#define FORTRAN
#define UNITM  XGMoveWindow
#define UNITL  xgmovewindow
#define UNITU  XGMOVEWINDOW
#define UNITM_ XGMoveWindow_
#define UNITL_ xgmovewindow_
#define UNITU_ XGMOVEWINDOW_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGMoveResizeWindow ***/
#define FORTRAN
#define UNITM  XGMoveResizeWindow
#define UNITL  xgmoveresizewindow
#define UNITU  XGMOVERESIZEWINDOW
#define UNITM_ XGMoveResizeWindow_
#define UNITL_ xgmoveresizewindow_
#define UNITU_ XGMOVERESIZEWINDOW_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGElapsedTime ***/
#define FORTRAN
#define UNITM  XGElapsedTime
#define UNITL  xgelapsedtime
#define UNITU  XGELAPSEDTIME
#define UNITM_ XGElapsedTime_
#define UNITL_ xgelapsedtime_
#define UNITU_ XGELAPSEDTIME_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"

/*** XGGetTimeString ***/
#define FORTRAN
#define UNITM  XGGetTimeString
#define UNITL  xggettimestring
#define UNITU  XGGETTIMESTRING
#define UNITM_ XGGetTimeString_
#define UNITL_ xggettimestring_
#define UNITU_ XGGETTIMESTRING_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGGetSystemTime ***/
#define FORTRAN
#define UNITM  XGGetSystemTime
#define UNITL  xggetsystemtime
#define UNITU  XGGETSYSTEMTIME
#define UNITM_ XGGetSystemTime_
#define UNITL_ xggetsystemtime_
#define UNITU_ XGGETSYSTEMTIME_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XCToLower ***/
#define UNITM  XCToLower
#define TYPE   EXPORT void
#define PROTOT (char *);
#include "alias.h"
 
/*** XFtolower ***/
#define FORTRAN
#define UNITM  XFToLower
#define UNITL  xftolower
#define UNITU  XFTOLOWER
#define UNITM_ XFToLower_
#define UNITL_ xftolower_
#define UNITU_ XFTOLOWER_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSystem ***/
#define FORTRAN
#define UNITM  XGSystem
#define UNITL  xgsystem
#define UNITU  XGSYSTEM
#define UNITM_ XGSystem_
#define UNITL_ xgsystem_
#define UNITU_ XGSYSTEM_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGRand ***/
#define FORTRAN
#define UNITM  XGRand
#define UNITL  xgrand
#define UNITU  XGRAND
#define UNITM_ XGRand_
#define UNITL_ xgrand_
#define UNITU_ XGRAND_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGPisBitmapFileHeader ***/
#define FORTRAN
#define UNITM  XGPisBitmapFileHeader
#define UNITL  xgpisbitmapfileheader
#define UNITU  XGPISBITMAPFILEHEADER
#define UNITM_ XGPisBitmapFileHeader_
#define UNITL_ xgpisbitmapfileheader_
#define UNITU_ XGPISBITMAPFILEHEADER_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGPisBitmapFile ***/
#define FORTRAN
#define UNITM  XGPisBitmapFile
#define UNITL  xgpisbitmapfile
#define UNITU  XGPISBITMAPFILE
#define UNITM_ XGPisBitmapFile_
#define UNITL_ xgpisbitmapfile_
#define UNITU_ XGPISBITMAPFILE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGWriteBitmapFile ***/
#define FORTRAN
#define UNITM  XGWriteBitmapFile
#define UNITL  xgwritebitmapfile
#define UNITU  XGWRITEBITMAPFILE
#define UNITM_ XGWriteBitmapFile_
#define UNITL_ xgwritebitmapfile_
#define UNITU_ XGWRITEBITMAPFILE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *, int *, int *, int *);
#include "alias.h"

/*** XGChdir ***/
#define FORTRAN
#define UNITM  XGChdir
#define UNITL  xgchdir
#define UNITU  XGCHDIR
#define UNITM_ XGChdir_
#define UNITL_ xgchdir_
#define UNITU_ XGCHDIR_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGCreatePixmapFromBitmapData ***/
#define FORTRAN
#define UNITM  XGCreatePixmapFromBitmapData
#define UNITL  xgcreatepixmapfrombitmapdata
#define UNITU  XGCREATEPIXMAPFROMBITMAPDATA
#define UNITM_ XGCreatePixmapFromBitmapData_
#define UNITL_ xgcreatepixmapfrombitmapdata_
#define UNITU_ XGCREATEPIXMAPFROMBITMAPDATA_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGCreateBitmapFromData ***/
#define FORTRAN
#define UNITM  XGCreateBitmapFromData
#define UNITL  xgcreatebitmapfromdata
#define UNITU  XGCREATEBITMAPFROMDATA
#define UNITM_ XGCreateBitmapFromData_
#define UNITL_ xgcreatebitmapfromdata_
#define UNITU_ XGCREATEBITMAPFROMDATA_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGGetBitmapDataPointer ***/
#define FORTRAN
#define UNITM  XGGetBitmapDataPointer
#define UNITL  xggetbitmapdatapointer
#define UNITU  XGGETBITMAPDATAPOINTER
#define UNITM_ XGGetBitmapDataPointer_
#define UNITL_ xggetbitmapdatapointer_
#define UNITU_ XGGETBITMAPDATAPOINTER_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGIconifyWindow ***/
#define FORTRAN
#define UNITM  XGIconifyWindow
#define UNITL  xgiconifywindow
#define UNITU  XGICONIFYWINDOW
#define UNITM_ XGIconifyWindow_
#define UNITL_ xgiconifywindow_
#define UNITU_ XGICONIFYWINDOW_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGSetWindowBackground ***/
#define FORTRAN
#define UNITM  XGSetWindowBackground
#define UNITL  xgsetwindowbackground
#define UNITU  XGSETWINDOWBACKGROUND
#define UNITM_ XGSetWindowBackground_
#define UNITL_ xgsetwindowbackground_
#define UNITU_ XGSETWINDOWBACKGROUND_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSetWindowBackgroundPixmap ***/
#define FORTRAN
#define UNITM  XGSetWindowBackgroundPixmap
#define UNITL  xgsetwindowbackgroundpixmap
#define UNITU  XGSETWINDOWBACKGROUNDPIXMAP
#define UNITM_ XGSetWindowBackgroundPixmap_
#define UNITL_ xgsetwindowbackgroundpixmap_
#define UNITU_ XGSETWINDOWBACKGROUNDPIXMAP_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGDrawText ***/
#define FORTRAN
#define UNITM  XGDrawText
#define UNITL  xgdrawtext
#define UNITU  XGDRAWTEXT
#define UNITM_ XGDrawText_
#define UNITL_ xgdrawtext_
#define UNITU_ XGDRAWTEXT_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int txt[60][132],int *,int fnt[60][MXBITS], \
                int *,int *,int *);
#include "alias.h"
 
/*** XGDrawPage ***/
#define FORTRAN
#define UNITM  XGDrawPage
#define UNITL  xgdrawpage
#define UNITU  XGDRAWPAGE
#define UNITM_ XGDrawPage_
#define UNITL_ xgdrawpage_
#define UNITU_ XGDRAWPAGE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int txt[60][132],int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGGrabPointer ***/
#define FORTRAN
#define UNITM  XGGrabPointer
#define UNITL  xggrabpointer
#define UNITU  XGGRABPOINTER
#define UNITM_ XGGrabPointer_
#define UNITL_ xggrabpointer_
#define UNITU_ XGGRABPOINTER_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGUngrabPointer ***/
#define FORTRAN
#define UNITM  XGUngrabPointer
#define UNITL  xgungrabpointer
#define UNITU  XGUNGRABPOINTER
#define UNITM_ XGUngrabPointer_
#define UNITL_ xgungrabpointer_
#define UNITU_ XGUNGRABPOINTER_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGSetSubwindowMode ***/
#define FORTRAN
#define UNITM  XGSetSubwindowMode
#define UNITL  xgsetsubwindowmode
#define UNITU  XGSETSUBWINDOWMODE
#define UNITM_ XGSetSubwindowMode_
#define UNITL_ xgsetsubwindowmode_
#define UNITU_ XGSETSUBWINDOWMODE_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGGrabServer ***/
#define FORTRAN
#define UNITM  XGGrabServer
#define UNITL  xggrabserver
#define UNITU  XGGRABSERVER
#define UNITM_ XGGrabServer_
#define UNITL_ xggrabserver_
#define UNITU_ XGGRABSERVER_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGUngrabServer ***/
#define FORTRAN
#define UNITM  XGUngrabServer
#define UNITL  xgungrabserver
#define UNITU  XGUNGRABSERVER
#define UNITM_ XGUngrabServer_
#define UNITL_ xgungrabserver_
#define UNITU_ XGUNGRABSERVER_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
/*** XGChangeActivePointerGrab ***/
#define FORTRAN
#define UNITM  XGChangeActivePointerGrab
#define UNITL  xgchangeactivepointergrab
#define UNITU  XGCHANGEACTIVEPOINTERGRAB
#define UNITM_ XGChangeActivePointerGrab_
#define UNITL_ xgchangeactivepointergrab_
#define UNITU_ XGCHANGEACTIVEPOINTERGRAB_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"
 
/*** XGSetLineAttributes ***/
#define FORTRAN
#define UNITM  XGSetLineAttributes
#define UNITL  xgsetlineattributes
#define UNITU  XGSETLINEATTRIBUTES
#define UNITM_ XGSetLineAttributes_
#define UNITL_ xgsetlineattributes_
#define UNITU_ XGSETLINEATTRIBUTES_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGCopyGC ***/
#define FORTRAN
#define UNITM  XGCopyGC
#define UNITL  xgcopygc
#define UNITU  XGCOPYGC
#define UNITM_ XGCopyGC_
#define UNITL_ xgcopygc_
#define UNITU_ XGCOPYGC_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"
 
/*** XGBell ***/
#define FORTRAN
#define UNITM  XGBell
#define UNITL  xgbell
#define UNITU  XGBELL
#define UNITM_ XGBell_
#define UNITL_ xgbell_
#define UNITU_ XGBELL_
#define TYPE   EXPORT void
#define PROTOT (int *);
#include "alias.h"
 
/*** XGDrawJezek ***/
#define FORTRAN
#define UNITM  XGDrawJezek
#define UNITL  xgdrawjezek
#define UNITU  XGDRAWJEZEK
#define UNITM_ XGDrawJezek_
#define UNITL_ xgdrawjezek_
#define UNITU_ XGDRAWJEZEK_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGDrawSegments ***/
#define FORTRAN
#define UNITM  XGDrawSegments
#define UNITL  xgdrawsegments
#define UNITU  XGDRAWSEGMENTS
#define UNITM_ XGDrawSegments_
#define UNITL_ xgdrawsegments_
#define UNITU_ XGDRAWSEGMENTS_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGGetByte ***/
#define FORTRAN
#define UNITM  XGGetByte
#define UNITL  xggetbyte
#define UNITU  XGGETBYTE
#define UNITM_ XGGetByte_
#define UNITL_ xggetbyte_
#define UNITU_ XGGETBYTE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGPutByte ***/
#define FORTRAN
#define UNITM  XGPutByte
#define UNITL  xgputbyte
#define UNITU  XGPUTBYTE
#define UNITM_ XGPutByte_
#define UNITL_ xgputbyte_
#define UNITU_ XGPUTBYTE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGGetBuff ***/
#define FORTRAN
#define UNITM  XGGetBuff
#define UNITL  xggetbuff
#define UNITU  XGGETBUFF
#define UNITM_ XGGetBuff_
#define UNITL_ xggetbuff_
#define UNITU_ XGGETBUFF_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *);
#include "alias.h"
 
/*** XGPutBuff ***/
#define FORTRAN
#define UNITM  XGPutBuff
#define UNITL  xgputbuff
#define UNITU  XGPUTBUFF
#define UNITM_ XGPutBuff_
#define UNITL_ xgputbuff_
#define UNITU_ XGPUTBUFF_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *,int *,int *);
#include "alias.h"

/*** XGOpenBinaryFile ***/
#define FORTRAN
#define UNITM  XGCloseBinaryFile
#define UNITL  xgclosebinaryfile
#define UNITU  XGCLOSEBINARYFILE
#define UNITM_ XGCloseBinaryFile_
#define UNITL_ xgclosebinaryfile_
#define UNITU_ XGCLOSEBINARYFILE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"

/*** XGCloseBinaryFile ***/
#define FORTRAN
#define UNITM  XGCloseBinaryFile
#define UNITL  xgclosebinaryfile
#define UNITU  XGCLOSEBINARYFILE
#define UNITM_ XGCloseBinaryFile_
#define UNITL_ xgclosebinaryfile_
#define UNITU_ XGCLOSEBINARYFILE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *);
#include "alias.h"

/*** XGReadBinaryFile ***/
#define FORTRAN
#define UNITM  XGReadBinaryFile
#define UNITL  xgreadbinaryfile
#define UNITU  XGREADBINARYFILE
#define UNITM_ XGReadBinaryFile_
#define UNITL_ xgreadbinaryfile_
#define UNITU_ XGREADBINARYFILE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"
 
/*** XGFileSize ***/
#define FORTRAN
#define UNITM  XGFileSize
#define UNITL  xgfilesize
#define UNITU  XGFILESIZE
#define UNITM_ XGFileSize_
#define UNITL_ xgfilesize_
#define UNITU_ XGFILESIZE_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *);
#include "alias.h"


/*** XGGetRGB ***/
#define FORTRAN
#define UNITM  XGGetRGB
#define UNITL  xggetrgb
#define UNITU  XGGETRGB
#define UNITM_ XGGetRGB_
#define UNITL_ xggetrgb_
#define UNITU_ XGGETRGB_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"

/*** XGGetRGBFromPixel ***/
#define FORTRAN
#define UNITM  XGGetRGBFromPixel
#define UNITL  xggetrgbfrompixel
#define UNITU  XGGETRGBFROMPIXEL
#define UNITM_ XGGetRGBFromPixel_
#define UNITL_ xggetrgbfrompixel_
#define UNITU_ XGGETRGBFROMPIXEL_
#define TYPE   EXPORT void
#define PROTOT (int *,int *,int *,int *);
#include "alias.h"

/*** XGFlushStdOut ***/
#define FORTRAN
#define UNITM  XGFlushStdOut
#define UNITL  xgflushstdout
#define UNITU  XGFLUSHSTDOUT
#define UNITM_ XGFlushStdOut_
#define UNITL_ xgflushstdout_
#define UNITU_ XGFLUSHSTDOUT_
#define TYPE   EXPORT void
#define PROTOT (void);
#include "alias.h"
 
 
/* Global variables */

EXPORT Display *display;
EXPORT int screen;
EXPORT Screen *screen_ptr;
EXPORT Window root_window;
EXPORT char **argv;
EXPORT int argc;
EXPORT char err_msg[MXCHAR];
EXPORT Window current_win;
EXPORT GC current_GC;
EXPORT Pixmap current_pixmap;
EXPORT Drawable current_drawable;
EXPORT XEvent report;
EXPORT int fg_kontrola;
EXPORT char Funame[MXFUNALEN];
EXPORT XFontStruct font_struct[MXRASFN];
EXPORT char **fontlist; 
EXPORT FILE *fbitmap;
EXPORT FILE *fr;
EXPORT FILE *fw;
